' code snippet file for use with shivaEngine3 
' released: 5.25.06
'
' *** COPYRIGHT NOTICE ***
'
' written by shiva
' Thanks to all the other authors
' Contact Info : p_d_sanderson@hotmail.com
'
' All rights are reserved by p.d.sanderson (shiva)
' You may release, or modify for release any portion of this product, as long as it is not 
' part of a commercial product or venture. 
' This code snippet was meant to be expanded, so please contact the author for additions 
' to this base script. All submissions welcome.
'
' The above copyright and remarks MUST be included with this table. Please credit use of
' this script for your own tables.
'
' Please keep any modifications for release as separate code snippet files so others can use 
' it for their tables.
'
' *** 1823 - (Playboy) Calendar Button Targets / Playmate Award ***
'
' The Calendar Button Targets are pretty much like the target bank code, except the push back
' effect interval puts the front target wall back up after the interval, as opposed to keeping it dropped
' (It is a button target after all) The timer for this is the the Timer object TimerBT1823a. I used 100
' for the interval, seems to look better. You can just play with the interval in the editor.
'
' Other than that, the code is pretty much the same, the scoring for the bank is different for the
' PlayMate Award horseshoe, and it just needs the one timer, you don't need the second timer as Button
' targets don't drop.
 
Dim BT1823CalendarCount ' Holds value for amount of times Calendar bank is down
 
 ' The intial routine to set up values for Table Start and at a New Ball. Like the Target Bank code, we
 ' call it by the sub name: SetCalendar1823() and place it in the SetNewBall()
 ' The code is pretty much the same way as the targets, keys etc.
 
 ' set initial values
 
Sub SetCalendar1823()
 
 	' reset the variable to 0 so we make sure it's cleared if there is other players
	BT1823CalendarCount=0
 
 	'pop down pushed in effect targets
	For Each target in BT1823b
     	target.IsDropped=1 
 	Next
 
 	' Now we check the memory, see if these lights are on, and set the variable accordingly so the script
 	' can keep proper track. We add the gameover to prevent the variable from increasing during attract mode
 	' It shouldn't, but lets just make sure anyway
 
 	If gameover=0 then
 		If LightPlaymateAward2.State=1 then BT1823CalendarCount=1
 		If LightPlaymateAward3.State=1 then BT1823CalendarCount=2
 	end if
 
 	' Now we check the skill level. If it's set to 1, reset the Calendar lights so the player has to make
 	' them all over again to light the next Playmate award at the horseshoe. Any lights at the award will
 	' stay on and be collected if triggered
 
	If SetSkillLevel>0 then
		For Each Light in LightBT1823a 'resets matching Lights
			light.state = 0
		Next
 	end if
 
 	' Now skilllevel 2. We already turned off the lights (because we used a greater than, so the script
 	' just looked to see if the value was over 1) so lets get nasty, and reset the Playmate awards and
 	' turn them off as well. In other words, back to the very beginning
 
 	If SetSkillLevel>1 or Gameover=1 then
 		LightPlaymateAward2.State=0
 		LightPlaymateAward3.State=0
 		' don't forget to reset the variable as well
 		BT1823CalendarCount=0
 	end if
 
end sub

' the main routine, that points to the collection. You know the drill by now...
 
Sub BT1823a_Hit(Index)
 
	'SetNewBall() HOOK sub turns these lights off at start of each new ball
 
 	BT1823a(Index).IsDropped=1 ' drops first front target so we get the...
 	BT1823b(Index).IsDropped=0	' pushed in effect, as we pop a target just behind the first
 
 	' and run a timer, so we can reset it back after a delay Interval set in the editor for the timer
 	TimerBT1823a.Enabled=1
 
 	' now we start checking the routine, first make sure the game isn't in a tilt state
 
 	If tilt=0 and gameover=0 then
 
		addscore 500
 		StopAllSounds() ' stop sounds if playing
 
		' We use the lights to control this, as it's just as simple as a variable. It's part of a collection
 		' you can add. Just make sure the amount of lights in that collection match the target amounts
 		' in it's collections. We do this before we check all the lights are on, so the additional code
 		' will execute properly.
 
 		LightBT1823a( Index ).state = 1 ' light the matching light to the target
 
 		' Adds count to Railway Feature for 5000 points (every 3rd time) Other objects also trigger
 		' the count as well. See the Railway section within the code for a more detailed description
 
 		GetSpecialFeatureCount()
 
 		' The same, but for if the Outlanes are lit (This will change with every hit though)
 
 		AlternateOutlaneLights()

 		' Lets look at the collection first. Remember we match the lights to the Targets, so first we
 		' see if any lights in that collection are Off. If one or more is off, we execute this little
 		' code, and leave the subroutine
 
		For	each light in LightBT1823a
 
			' This looks to see if the matching light is off first 
			If Light.state=0 Then ' if lights are OFF. If the lights are On, then this will be ignored 
				
				' we use the GetScoreBells variable to decide if we want to use the built in sound
				' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
				' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
				' sound, and is already added to the engine
				If GetScoreBells=0 then PlaySound "ButtonOff" ' Play that sound
				
				Exit sub 'if the lights are OFF, exit this sub now, do not do the next code
			end if
 
 		Next
 
		' This is for the lights being all ON
		'I run a stopsound for both button sounds, just in case
 		
		' we use the GetScoreBells variable to decide if we want to use the built in sound
		' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
		' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
		' sound, and is already added to the engine
		If GetScoreBells=0 then PlaySound "ButtonOff" ' Plays sound
		
		AddBonus() ' Add a bonus
 
 		' Increase the variable that holds the value for how many times this has been made.
 
 		BT1823CalendarCount=BT1823CalendarCount+1
 
 		' Now we use a case setting to give special instructions on what we want to happen with each
		' target bank down. You can add anything here, from multipliers, extra balls, specials
		' whatever. we have 2 case statements here, so it will execute case 1 first, then case 2
		' will execute the 2nd time a bank is made. Case Else means everytime afterwards if there's
		' no more cases defined. To add a third case, just put in case 3 and the code, and so on.
		' You can have as many cases as you want.
 
		Select Case BT1823CalendarCount
 
			Case 1
 				If LightPlaymateAward2.State=0 or LightEB.State=0 then ' If Extra ball isn't made this ball
					LightPlaymateAward2.State=1 ' light for extra ball at horseshoe
 				else ' if light is on
 					exit sub
 				end if
 
			Case Else ' keep doing this after first case
 			' First we check if Extra Ball has been made
 				If LightPlaymateAward2.State=0 or LightEB.State>0 then ' check playmate or EB lit on
					LightPlaymateAward3.State=1 ' Light the special at horseshoe
 				else
 					BT1823CalendarCount=1 ' forces value back one, so it will keep looping
 					exit sub
 				end if
 		
		End Select
		
 		' Switch the lights off so we can start again
		For	each light in LightBT1823a
 			light.state=0
 		next
 
 	end if
 
End Sub

 ' Timer to reset the front target back up, and the back target back down 
Sub TimerBT1823a_Timer()
 
 	TimerBT1823a.Enabled=0
 
 	For Each target in BT1823b
     	target.IsDropped=1
 	Next
 
 	For Each target in BT1823a
     	target.IsDropped=0
 	Next
 
end Sub

' Horseshoe code (Playmate award)
 
' Making the Calendar gives a award at the Horseshoe above. it's pretty simple code, in fact, it's
' the same way as other subs.
 
 Sub PlaymateAward_Hit()
 
 	If tilt=0 and gameover=0 then
 
 		StopAllSounds() ' stop sounds if playing
 		
 		' we use the GetScoreBells variable to decide if we want to use the built in sound
		' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
		' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
		' sound, and is already added to the engine
		If GetScoreBells=0 then PlaySound "RolloverOn":end if
		
 		AddScore 5000
 		AddBonus
 
 		' Adds count to Railway Feature for 5000 points (every 3rd time) Other objects also trigger
 		' the count as well. See the Railway section within the code for a more detailed description
 		GetSpecialFeatureCount()
 
 		' The same, but for if the Outlanes are lit (This will change with every hit though)
 		AlternateOutlaneLights()

 		' Easy way, we switch on the lights at the Calendar main sub, so lets just see if one of those
 		' lights is on, and act accordingly.
 		' we check for Extra Ball light first
 
 		If LightPlaymateAward2.State=1  then ' If Extra ball is lite
 
			LightPlaymateAward2.State=0 ' light is off for extra ball at horseshoe
 
 		' This is the call to the engine. Extra Ball feature is part of the standard package of se3
 		' The code is actually complex, and is required in quite a few places, so to make it easy
 		' you just need to add this one line to get a extra ball automatically in your table
 
 			GetExtraBall()
 
 		end if
 
 		' check for Special light on
 		If LightPlaymateAward3.State=1  then ' If Special is lite
 
			LightPlaymateAward3.State=0 ' light off for Special at horseshoe
 
 		' Same as GetExtraBall(), built in routine that handles Specials and saving the special etc.
 		' In other words, when you want a special to happen, just put GetSpecial in your code where you
 		' want it.
 
 			GetSpecial()
 		end if
 
 	end if
 
 end sub