' code snippet file for use with shivaEngine3 
' released: 5.25.06
'
' *** COPYRIGHT NOTICE ***
'
' written by shiva
' Thanks to all the other authors
' Contact Info : p_d_sanderson@hotmail.com
'
' All rights are reserved by p.d.sanderson (shiva)
' You may release, or modify for release any portion of this product, as long as it is not 
' part of a commercial product or venture. 
' This code snippet was meant to be expanded, so please contact the author for additions 
' to this base script. All submissions welcome.
'
' The above copyright and remarks MUST be included with this table. Please credit use of
' this script for your own tables.
'
' Please keep any modifications for release as separate code snippet files so others can use 
' it for their tables.
'
' *** 1823 - (Playboy) Gates/Slings ***
'
' This is the simplest collection here, as we have the three gates, and we want the "clink" sound when a 
' ball passes through a gate. We just made our gates, Kept the name, as they are ordered Gate1, Gate2, anyway
' and then added them to the GATE collection. If we add any new gates, just create the gate in the editor,
' and add it to the GATES collection. You can add as many gates as you want. 
' If you don't like the sound, you can replace it, use the Table/Sound Manager menu at the top, hilight 
' the Gate sound, and select "Reimport From" and point to a different sound. It will still be called Gate, 
' but will play the sound you selected.
' If you look at the collection, you will see that the Gate by the trough is also included.
 
' This calls the collection itself. We could code subroutines for each gate, but instead, by having
' a collection, we can tell the script to use this one piece of code for all the gates that are in that 
' collection. 
 
Sub GATES_Hit(Index)
 	
 	' This is all, just play that "clink" sound everytime a ball goes through a gate
 	PlaySound "Gate"
 
end sub
 
' *** Slings ***
' just a basic example of slings. We use the same way as the Gates, we play the sound, but now we also
' add a score as well.

 ' Just make a collection in the editor, call it 'Slings' and add the sling objects to it.
' To use this, make sure that "Fire Events for this Collection" is CHECKED in the box field. 
' the other difference for a sling compared to a gate is we don't use the _Hit() at the sub name, 
' we use the _Slingshot instead for slings
 
Sub Slings_Slingshot( Index )
 
 	' This stops sounds if they are playing. This is shivaEngine3 code, and will turn off any preset sounds 
 	' used in the engine as part of the engine code. This is very handy, as it will prevent multiple
 	' sounds from playing at the same time, which can be very jarring, and cause a very "static" effect
 
	StopAllSounds() 
 
 	' Check to see if it's not tilted, so we can play the sound and score
 
 	If tilt=0 then
 
 	' just 2 sounds, one for the mechanical type sound, the other, sling2, is the eletronic sound, which is 
 	' part of the standard sound set for se3. You can replace or delete these sounds in the Tables/Sound 
 	' Manager Menu 
		PlaySound "Sling"
		
		' we use the GetScoreBells variable to decide if we want to use the built in sound
		' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
		' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
		' sound, and is already added to the engine
		If GetScoreBells=0 then PlaySound "Sling2" 
 
 	' Now we score 10 points for each hit
		AddScore 10
 
 	end if
end sub

' *** 1823 - (PlayBoy) Grotto Gate ***
 
' Note, this uses a spinner object instead of a gate, so we can attach the gate wire image. The code here
' is just to control some walls to prevent the ball from escaping back out
 
' drops wall to allow access
Sub TriggerGrottoOpen_hit():PlaySound "Gate":GrottoGateWall.IsDropped=1:end sub ' top wire gate
 
' pops up wall to close access
Sub TriggerGrottoClose_hit():GrottoGateWall.IsDropped=0:end sub ' grotto lane