' code snippet file for use with shivaEngine3 
' released: 5.25.06
'
' *** COPYRIGHT NOTICE ***
'
' written by shiva
' Thanks to all the other authors
' Contact Info : p_d_sanderson@hotmail.com
'
' All rights are reserved by p.d.sanderson (shiva)
' You may release, or modify for release any portion of this product, as long as it is not 
' part of a commercial product or venture. 
' This code snippet was meant to be expanded, so please contact the author for additions 
' to this base script. All submissions welcome.
'
' The above copyright and remarks MUST be included with this table. Please credit use of
' this script for your own tables.
'
' Please keep any modifications for release as separate code snippet files so others can use 
' it for their tables.
'
' *** 1823 - (Playboy) Railway ***
'
' Sometimes, a arcade table has a special feature, that will switch on a special scoring
' feature based on how many times certain objects are hit. PlayBoy used this among others
' where the Railway lane (lane to the right of the target banks) would lit after 3 hits to objects. 
' With Playboy, it was if a key lane was hit, the calendar Button targets, or the drop target bank.
 
' this is the variable that holds a value to keep track of the times a object(s) is hit
' and then will lite a feature or light
 
Dim SpecialFeatureCount
 
' Lane to the right of the target banks. This has special code, as the 5k light
' will lite if certain objects are hit every 3 times. This is the actual hit code that scores the value
' we set the code and the count SpecialFeatureCount variable in the sub that's used by the other subroutines
 
Sub TriggerRailway_Hit()
  
 	' We drop the walls that make up the wire trigger for the effect
 	WireRailway1.IsDropped=1
 	WireRailway2.IsDropped=1
 
 	' now to see if we are titled, or a game is playing
 	If tilt=0 or gameover=0 then
 		StopAllSounds() ' stop sounds if playing
 
 		' lets check that 5k light is off or on.
 		If LightRailway.State=0 then ' the first part see's if the light is off 
 		
			' we use the GetScoreBells variable to decide if we want to use the built in sound
			' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
			' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
			' sound, and is already added to the engine
			If GetScoreBells=0 then PlaySound "ButtonOff"	' Bally used the same sounds for a lot of things
 			
			AddScore 500 ' unlit=500 points
 			AddBonus()
 		else ' if that light is on
 		
 			' we use the GetScoreBells variable to decide if we want to use the built in sound
			' system for Bally/EM type scoring or not. If we don't then set GetScoreBells to 0
			' and add the sound here. The GetScoreBells feature, if on (GetBalls=1) will play a set
			' sound, and is already added to the engine
			If GetScoreBells=0 then PlaySound "ButtonOn" ' different sound if lit
			
 			AddScore 5000 ' lit=5000 points
 			AddBonus()
 			' Make sure we reset so the count starts back to 0 to start over
 			LightRailway.State=0 ' switch the light off
 			SpecialFeatureCount=0 ' reset the value to start over
 		end if
 
 	end if
 
end sub
 
' Remember we dropped the wire trigger walls in the hit event? We can pop them
' back up with a timer if we wanted, but we don't have to. The UnHit event is
' what happens when the ball no longer is touching the trigger, which is real
' handy for things like wire triggers, as we can just use that to pop the wires
' back up. If you look real closely, you will see that I have a set of walls
' under the wires, that are colored darker. They don't do anything, other than
' make the effect better
 
Sub TriggerRailway_UnHit()
 	' We pop up the walls for the wire trigger effect
 	WireRailway1.IsDropped=0
 	WireRailway2.IsDropped=0
end sub
 
' This is all you need to do, just add GetSpecialFeatureCount() to the object hit event subs you want, 
' and make sure that SpecialFeatureCount=0 is in your SetNewBall() sub. Scoring and everything is
' already in the TriggerRailway routines. For this example, every 3rd object hit will light the
' Railway lane for 5000 points, and will switch itself off with a next object hit
 
Sub GetSpecialFeatureCount()
 
 	' check to make sure not tilted etc...
 	If tilt=0 or gameover=0 then 
 
 		' increase the value by 1
 		SpecialFeatureCount=SpecialFeatureCount+1 
 
 		' now we see if the value is 3
 		If SpecialFeatureCount=>3 then
 			LightRailway.State=1 ' turn on the light
 			SpecialFeatureCount=0 ' and reset the value to start over
 		else ' if the value is LESS than 3
 			LightRailway.State=0 ' make sure the light is off. More of a error catcher than anything
 		end if
 	end if
end sub