' shivaEngine3  
' by shiva
' Thanks to Cold1 for the orginal version, and all other authors
' 
' *** Main Engine ***
' COPYRIGHT NOTICE
' shivaEngine 3 by shiva
' Contact Info : p_d_sanderson@hotmail.com
'
' All rights are reserved, not for re-release, or as a commercial product
' The entire contents of this product, including any portions in whole or in part, including 
' this script, table layout, or graphics may not be duplicated, modified or reproduced in 
' any format.
' You may not release, file mirror or modify for release any portion of this product unless 
' permission is given by the author of this product. This engine was meant to be expanded,
' so please contact the author for additions to this base script. All submissions welcome.
'
' Based on shivaEngine Build 1_8 - January 2002 by shiva, and Cold1
' Some examples were taken from other test scripts, authors uncredited in that script.
' The above copyright and remarks MUST be included with this table. Please credit use of
' this script for your own tables.
' This engine is still a work in progress, and should be considered a early build release.

' July 2006 
' *** Build 7.14.06 ***
' - Moved SetBallLost in drain hit code to prevent errors with memory system saving lights
' - Split the drain code to two sub routine sections. The drain hit is the section that
'   has the initial values, and the second is for the bonus count. By physically separating
'	the routines, we now can add code before we start the bonus timer. This allows us to
'	use custom bonus count routines now
' - Added new variable: HoldEndOfBall= x to drain code. By setting this to 1, this will cause the
' 	engine to execute any code in the SetBallLost HOOK and bypass the bonus countdown routine 
'	or delay the count till afterwards with a timer. To start the bonus Count afterwards, just
' 	add this at the very end of your code to be executed:
'			GetEndofBallBonus()
'	If you don't want a bonus countdown afterwards, then add this instead:
'			NewBall()
'	NOTE: this is untested for BallSaver and Multiball. Changes made be made as bugs found

' NOTE: THIS ENGINE IS SET UP TO BE SEPARATE FROM THE ACTUAL UNIQUE TABLE CODE.
' THERE SHOULD BE NO NEED TO CHANGE ANY OF THIS!!! 

				Rem *****************************************
				Rem ***   General Declarations Section    ***
				Rem *****************************************
							
' This is where you declare all of the variables that will be used in your code.
' This section automatically gets executed when you start the table.

' Declare common variables

Dim GameOver 		' Tracks the status of the game
Dim Score(4) 		' Tracks the player's score
Dim Credits 		' Tracks the number of credits
Dim MaxCredits ' Maximum amount of credits you can have
Dim Ball 		' The number of the current ball in play
Dim Balls 		' Number of balls per game
Dim x,y,z 			' General use variable
Dim HighScore 		' Tracks the game's high score
Dim Goal1 		' First replay score
Dim Goal2 		' Second replay score
Dim Made1(4) 		' Tracks if we already received the first replay
Dim Made2(4) 		' Tracks if we already received the second replay
Dim ExtraBall 		' Tracks when we receive an extra ball. One extra ball per ball in play is assumed.
Dim Tilt 		' Tracks the games tilt status
Dim Newtilt 		' The current nudge action
Dim Oldtilt 		' The last nudge action
Dim Tiltswing 		' Tracks the tilt bob swing
Dim seBallInTrough ' variable to indicate the ball is in trough area
Dim Points 		' Tracks the value of the current scoring object
Dim Bonus 		' Tracks the end of ball bonus
Dim BonusCountMax ' Sets Maximum amount of Bonus for one ball (see Init to adjust value)
Dim BonusTimerIntervalStart ' Starting delay time for between bonus counts
Dim BonusTimerIntervalDecreaseBy 'decreases by a set amount each interval after each bonuscount
Dim BonusTimerIntervalMinimumTime ' forced absolute min time between bonus counts
Dim BonusAmount 'points for each bonus
Dim seBLightState ' holds state value for bonus and multi (used as a future option)
Dim HoldBonus		' Variable to store bonus for multiplier countdown
Dim HoldMult		' Variable to hold Mult for collect bonus
Dim Mult 		' Bonus multiplier
Dim BonusCounted 	' Bonus count tracker
Dim Player 		' Current player
Dim Players 		' Total players
Dim TableFileName	' Table name for savefile
Dim Started		' Used for players at start of game
Dim PlayerLight(4)	' Variable to store amount of players lights
' Used for collections
Dim Light ' Used to store for AllLights Collection
Dim Index ' stores number of objects in collections
Dim Target ' Stores the target variable

' Load the player lights into arrays

Set PlayerLight(1) = LP1
Set PlayerLight(2) = LP2
Set PlayerLight(3) = LP3
Set PlayerLight(4) = LP4

' Set basic variables to an initial known state
GameOver = True 	' Set the game status to game over
Credits = 0 		' Set the credits to zero
Points = 0 			' Nothing is hit yet so this is zero
Player = 0 			' Game is over so there is no current player
Players = 0 		' Game is over so there are zero players
Started = False		' Haven't pressed the "1" key yet

' Events code
Dim KickCount 		' Counts the amount of times Kicker1 is made

' Multiball
Dim Multiball 		' Tracks amount of balls on the table
Dim Ballcount 		' counts balls on table

' BallSaver
Dim BallSaver ' flag to indicate whether to replay last ball - True if less than 20 seconds in play
Dim ReplayBall ' true if current ball is due to previous being lost within BallSaver period
Dim Drained	' set true in sub drain_hit, set false only when new ball hits gate
Dim BallSaverTimeInterval 'Defines the amount of time you want the ball saver to be on. (in milliseconds)

' This serves as the main initial values for the engine
Sub ResetTable()
 	' *** NO NEED TO CHANGE! THIS IS ENGINE CODE! ***
  
' These are general settings for the engine, no need to make any changes
  	x = 0 					' Set this to a known state. Don't forget to do this prior to use.
  	y = 0 					' Same as for x
  	ExtraBall = False 			' This is false when we do not have an extra ball.
  	Tilt = False 				' We are not currently in a tilt state
  	Newtilt = 0 				' There is no current nudge so it's zero
  	Oldtilt = 0 				' There is no old nudge so it's zero
  	Tiltswing = 0 				' The tilt bob is not swinging so it's zero
  	addscore 0 				' Display the current score which should be zero
  	bonus = 1 				' We start with 1 for the end of ball bonus
  	HoldBonus = bonus			' Store HoldBonus variable to match bonus
  	Mult = 1 				' Start with bonus multiplier at 1x
  	BonusCounted = False 			' This should always be false unless we just did a bonus count
  	KickCount = 1				' Kicker1 count starts at 1 
  	Drained = True				' Allow BallSaver 
  	Ball = 0 				' Set the ball number to zero
 	'variable for the bonus, so we can swap lightstate effects. This is internal, so do not change
  	seBLightState=1
  	MemoryReset()
  	'SetGameStart()
  	' Clear the score displays, scores, and replay trackers
  	For x = 1 To 4
  		score(x) = 0
  		made1(x) = False
  		made2(x) = False
  	Next
	seFlashDisplay = 0 ' set flashing display variable
  	' Multiball Code
  	Multiball = 1				' Multiball is on table at start
  	Ballcount = Ballcount + 1		' adds ball + multi
  	Ballcount = 2				' = 2
  	' We also tell the script a ball is in the trough, in case a tilt happens at 
  	' this exact moment 
 	'SetNewBall()
end sub
 
'  ***       MEMORY SYSTEM       ***
' This will handle up to 99 values as is, but if you want to change this...
' THIS SETS THE MEMORY VARIABLES, it's very important that the value number for MemorySlot, the second number
' for Memory, and the number for "slot=" are the SAME! Make sure you also have the same amount of MemorySlot code
' written for the "Set MemorySlot=" as well. They all should match.

Dim slot 'Purely for Looping purposes (unless you like to type a lot...)
slot=99 'should be the same number as values for KeyMemorySlot and last value in KeyMemory
'variable to set lights to memory, make sure the number matches with the last number in the Set MemorySlot code
Dim MemorySlot(99)
 ' variable matched to KeyMemorySlot. First value=amount of players, the second should match KeyMemorySlot
Dim Memory(4,99)

' Save Memory states
 Sub MemorySave()
 	dim p
 	for p = 1 to Slot
		On Error Resume Next
	Select Case Player
 			Case 1
 				if MemorySlot(p).State=0 Then Memory(1,(p)) = 0
 				if MemorySlot(p).State=1 Then Memory(1,(p)) = 1
 				if MemorySlot(p).State=2 Then Memory(1,(p)) = 2
 			Case 2
 				if MemorySlot(p).State=0 Then Memory(2,(p)) = 0
 				if MemorySlot(p).State=1 Then Memory(2,(p)) = 1
 				if MemorySlot(p).State=2 Then Memory(2,(p)) = 2
 			Case 3
 				if MemorySlot(p).State=0 Then Memory(3,(p)) = 0
 				if MemorySlot(p).State=1 Then Memory(3,(p)) = 1
 				if MemorySlot(p).State=2 Then Memory(3,(p)) = 2
 			Case 4
 				if MemorySlot(p).State=0 Then Memory(4,(p)) = 0
 				if MemorySlot(p).State=1 Then Memory(4,(p)) = 1
 				if MemorySlot(p).State=2 Then Memory(4,(p)) = 2
 		End Select
 	next
 end sub
 ' Load Memory states
 sub MemoryLoad()
 	dim p
 	for p = 1 to slot
	On Error Resume Next
 		Select Case Player
 			Case 1
 				if Memory(1,(p)) = 0 then MemorySlot(p).State=0:end if
 				if Memory(1,(p)) = 1 then MemorySlot(p).State=1:end if
 				if Memory(1,(p)) = 2 then MemorySlot(p).State=2:end if
 			Case 2
 				if Memory(2,(p)) = 0 then MemorySlot(p).State=0:end if
 				if Memory(2,(p)) = 1 then MemorySlot(p).State=1:end if
 				if Memory(2,(p)) = 2 then MemorySlot(p).State=2:end if
 			Case 3
 				if Memory(3,(p)) = 0 then MemorySlot(p).State=0:end if
 				if Memory(3,(p)) = 1 then MemorySlot(p).State=1:end if
 				if Memory(3,(p)) = 2 then MemorySlot(p).State=2:end if
 			Case 4
 				if Memory(4,(p)) = 0 then MemorySlot(p).State=0:end if
 				if Memory(4,(p)) = 1 then MemorySlot(p).State=1:end if
 				if Memory(4,(p)) = 2 then MemorySlot(p).State=2:end if
 		End Select
 	next
 end sub
 ' Reset Memory States
 Sub MemoryReset()
 	dim p
	On Error Resume Next
 	for p=1 to slot:Memory(1,p)=0:Memory(2,p)=0:Memory(3,p)=0:Memory(4,p)=0:next
 End Sub
 
'********************************************
' ***           Game Style System         ***
'********************************************
' This section holds the style definations to emulate various systems the companies used

Dim StyleNumber ' holds the style number variable
Dim SetTimerCase ' variable to set the case number for the delay in the code
' intervals for timer
Dim TableStartInterval,GameStartInterval,PlayerStartInterval,DrainDelayInterval
Dim MatchStartInterval,BallSaverMadeInterval
Dim GetBackgroundSound ' This allows the use of a background sound
' this is a simple variable used to execute additional code in the TimerControl_Timer after
' we set the interval, and the timer is executed. We use this for additional code we want 
' to use after the timer is finished, like to start the attract lights after TableStart.
' we set a value for this in the case statements just below, and then look for that value
' in the timer subroutine, and start that code if it's found.
Dim GetTimerControlCode 
' Skill Levels
Dim SetSkillLevel
' controls the speed of the reels as it counts for Bally type display system
Dim ReelSpeed 

' *** STYLE SYSTEM ***

' No need to change, as you have a custom section
' These are preset styles for the various era's and companies. 
Sub SetStyle(StyleNumber)

	ResetTable()
	SetBlankDisplay() ' Blanks reels
	Select case StyleNumber
		case 1 ' Bally1974. MPU AS-2518-17 (1974 to 1978). 
			' Games: BlackJack(ipd 309), Bow and Arrow (ipd 4770), EightBall (ipd 760)
			' Evel Knieval (ipd 4499), Freedom (ipd 4500), Mata Hari (ipd 4501)
			' Night Rider (ipd 4497), Power Play (ipd 1858), Strikes and Spares (ipd 2406)
			' Ball Saver
 			BallSaverTimeInterval = 0 
			' Match
			SetMatchInterval = 0 ' sets the initial time for the match to count.	
 			MatchAmountOfCounts = 0 ' The amount you want for the match to count
			' Bonus
			BonusAmount = 1000 ' score for each bonus count (usually 1000)
			BonusCountMax = 29 ' maximum amount of bonus (Up to 159)
			BonusTimerIntervalStart = 100 ' (rated in milliseconds. 250 = 1/4 of a second, 1000 = one second)
			BonusTimerIntervalDecreaseBy = 0
 			BonusTimerIntervalMinimumTime = 35
 			MaximumBonusMultiplier=4
 			' * Timer Delays *
			TableStartInterval=2500
			GameStartInterval=3500 
 			DrainDelayInterval=250
 			MatchStartInterval=500 ' delay for Pre Match code and sound (MatchStart)
			GetBackgroundSound=0 ' 0= no background sound used, 1 = a background sound is to be used.
			' Set our speed. We adjust this in the styles
			ReelSpeed=4	'Defines the speed of the reels, 1=slow, 9=fast, 3=default
			' calls system to play sound automatically through the scoring system
			GetScoreBells=1
		
		case 2 ' Bally1978 MPU AS-2518-17a (1978 to 1979).
			' games: Dolly Parton (ipd 698), Harlem Globetrotters (ipd 1125), Kiss (ipd 1386)
			' Lost World (ipd 1476), Nitro Ground Shaker (ipd 1682)
			' Playboy (ipd 1823), Star Trek (ipd 2355), Supersonic (IPD 2455)
			' 6 million Dollar Man (ipd 2165)
			' Ball Saver
 			BallSaverTimeInterval = 0 
			' Match
			SetMatchInterval = 0 ' sets the initial time for the match to count.	
 			MatchAmountOfCounts = 0 ' The amount you want for the match to count
			' Bonus
			BonusAmount = 1000 ' score for each bonus count (usually 1000)
			BonusCountMax = 39 ' maximum amount of bonus (Up to 159)
			BonusTimerIntervalStart = 200 ' (rated in milliseconds. 250 = 1/4 of a second, 1000 = one second)
			BonusTimerIntervalDecreaseBy = 0
 			BonusTimerIntervalMinimumTime = 35
 			MaximumBonusMultiplier=4
 			' * Timer Delays *
			TableStartInterval=2500
			GameStartInterval=3500 
 			DrainDelayInterval=250
 			MatchStartInterval=500 ' delay for Pre Match code and sound (MatchStart)
			GetBackgroundSound=0 ' 0= no background sound used, 1 = a background sound is to be used.
			' Set our speed. We adjust this in the styles
			ReelSpeed=3	'Defines the speed of the reels, 1=slow, 9=fast, 3=default
			' calls system to play sound automatically through the scoring system
			GetScoreBells=1
		case 3 ' Bally 1979
		' Paragon (ipd 1755),Silverball Mania (ipd 2156)
			SetCustomStyle()
		case 4 ' Bally 1980
			SetCustomStyle()
		case 5 ' Bally 1981
			SetCustomStyle()
		case 6 ' Williams System 3 (1977-1978)
		' (Contact, Disco Fever, Hot tip, Lucky Seven, World Cup)
			SetCustomStyle()
		case 7 ' Williams System 4 (1978-1979)
		' (Flash, Phoenix, Pokerino, Stellar Wars)
			SetCustomStyle()
		case 8 ' Williams System 6 and 6a (1979-1980)
		' (Blackout, Firepower, Gorgar, Lazer Ball, Scorpion, Time Warp, Tri Zone, Algar, Alien Poker)
			SetCustomStyle()
		case 9 ' Williams System 7 (1980-1984)
		' (Barracora, Black Knight, Cosmic Gunfighter, Defender, Firepower 2, Hyperball)
		' (Joust, Jungle Lord, Laser Cue, Pharaoh, Solar Fire, Star Light, Time Fantasy, Warlok)
			SetCustomStyle()
		case 10 ' Williams System 8-9 (1984-1985)
		' (Sorcerer, Space Shuttle)
			SetCustomStyle()
		case 0 ' if there's any other number set
			SetCustomStyle() ' this is for the user to change and do his own style
	end select
	SetTimer 1
end sub

' *** MAIN DELAY TIMER ***

' Main event timer, used for the seperate styles, and also delays before events happen
' These are used for sounds and prompts before say the trough will kick out a ball. The 
' variables used to define styles are actually timer intervals, and used by this routine
' as well as the match/bonus etc routines.

Sub SetTimer(SetTimerCase)

		seBallInTrough=1 ' this prevents the tilt error at gamestart
		
		' Since it's handy, lets control whether or not we want the background sound to play
		' We stop the background sound first, play the sound within the case statements, and
		' then restart the background sound after the interval is over
		StopSound "Background"
		
		' This sets the same value of GetTimerControlCode to SetTimerCase, so we can use a 
		' case statement in the timer for any additional code.
		GetTimerControlCode=SetTimerCase
		
		Select case SetTimerCase
		
		case 1' "TableStart" ' Opening delay for table start
		
			ScoreDelay.TimerInterval=540\ReelSpeed	'Set the score display speed
			SetNewBall()
			' we stop the timer that alternates the HS and score, or it looks funny
			'TimerAttract.Enabled = False
			' Just put in a TableStart.wav sound, and set the timer for the amount of time
			' you wish to delay from when the table is started from the editor to when you
			' want the light Attract mode to START. Handy for start up sounds etc.
			If TableStartInterval>0 then
			
				' play the sound. you can load in a different sound into the sound editor,
				' just keep it the same file name, and change the GameStartInterval to match
				' the time. Sound Editors such as Goldwave will tell you the total file time in 
				' milliseconds. This sets the sound for a table when it's first switched on
				' you can delete it and set the TableStartInterval to 0 if you don't want it
				' It then points to the code in the table, and calls the electronic sound
				' that most games have (TableStart.wav)
				StopAllSounds() ' stops all sounds
				PlaySound "TablePowerOn" 
				
				' You set can GameStartInterval in the VP editor itself. This is just how long you want
				' the delay before the ball will pop out. Most games will play the sound first, then
				' release the ball afterwards 
				TimerControl.interval=TableStartInterval
				
				' This sets a value of one to the variable, so in the timer code, it looks
				' for this value, and if found, will start the attract lights.
				' Okay, interval set, once it's over, go to timer so you can automatically play the BG
				' sound again
				TimerControl.enabled=1
				
			end if	
		case 2 '"GameStart" 'delay for game start till when the ball is popped out
			' this checks you have a timer interval set, if it's 0, then just ignore
			' this then. It won't play the sound, or execute any other code. Sometimes
			' you may not want a delay or a sound...
			If GameStartInterval>0 then
			' turn off this timer (if on)
				TimerControl.enabled=0
			' Turn off match end timer. If you start a new game while this timer is still
			' on, you will get the Light Attract mode at the start of the game!
				TimerGameEnd.Enabled=0
			' turn off the attract mode
             	TimerAttract.Enabled = False
             
             ' Lets handle lights and display.
             	For Each Light in GameOverLight:Light.State=0 : Next ' turn off the game over light
             	For Each Light in AllLights:Light.State=0 : Next ' turn off the lights, we define which lights we want in NewBall()
             	For Each Light in MatchLight:Light.State=0 : Next' Turn off the match light
             	For Each Light in BIPLight:Light.State=1 : Next ' Turn on the ball light
                LightEB.State = 0	 				' Turn off the extra ball light
                
                ' we turn off all the lights first, as it looks better, and prevents errors
                ' with the start of a new game
                For Each light in AllLights
                	light.state=0
                next
                
				' we stop the sounds in case it's still playing when another player is added
				' play the sound. you can load in a different sound into the sound editor,
				' just keep it the same file name, and change the GameStartInterval to match
				' the time. Sound Editors such as Goldwave will tell you the total file time in 
				' milliseconds 
				' You set can GameStartInterval in the VP editor itself. This is just how long you want
				' the delay before the ball will pop out. Most games will play the sound first, then
				' release the ball afterwards.

				TimerControl.interval=GameStartInterval
				
				' Okay, interval set, once it's over, go to timer so you can automatically play the BG
				' sound again
				TimerControl.enabled=1
			end if
		case 3 '"Drain2" ' delay for drain before bonus count starts. 
		
			' You can put in a sound here before your bonus will start counting, similar
			' to System 9 games like Sorcerer			
			If DrainDelayInterval>0 then
				StopAllSounds() ' stops all sounds
				PlaySound "Drain2":TimerControl.interval=DrainDelayInterval
				TimerControl.enabled=1
			end if
			
		case 4 '"PreMatch" ' delay for last ball lost till match starts
			If MatchStartInterval>0 then
				StopAllSounds() ' stops all sounds
				PlaySound "MatchStart":TimerControl.interval=MatchStartInterval
				TimerControl.enabled=1
			end if
		case 6 ' "BallSaverMade" ' delay for ball saver before ball pops out
			If BallSaverMadeInterval>0 then
				StopAllSounds() ' stops all sounds
				PlaySound "BallSaverMade":TimerControl.interval=BallSaverMadeInterval
				TimerControl.enabled=1
			end if
		end select

end sub

Sub TimerControl_Timer
	TimerControl.enabled=0
	seBallInTrough=0 ' this prevents the tilt error at gamestart
	If Gameover =0 and tilt =0 then ' look to see if a game is in progress
		' look to see if you have selected a background sound to be played
		If GetBackgroundSound = 1 then 
			PlaySound "Background,-1" ' This loops the sound over and over until stopped
		end if
	else ' no background sound wanted
		StopSound "Background" ' no game, but lets force the issue, and not play the sound
	end if
	
	' Now we look to see if there's any additional code that needs to be executed. Remember
	' that we made GetTimerControlCode the same value as SetTimerCase, so we can use a simple
	' case statement here.
	Select case GetTimerControlCode
		case 1 
			' This is after the delay set by the "TableStart" case, so we play the TableStart
			' sound while having all the lights off, and then switch on light Attract at the
			' timer interval we had set, so we have a "start up" effect. The PlaySound
			' is the mechanical sound of targets resetting, you can replace this with a 
			' sound with the exact same filename, or just delete it if you want no sound.
			' and lets make it real simple, stop any sounds playing
			
			StopAllSounds() ' stops all sounds
			PlaySound "TableStart" ' Play the opening electronic sound
			AttractLights() ' Starts the light Attract routine
			PlaySound "TableStartReset" ' make the mechanical sound
			
			' turn on the credit indicator light if you have credits saved from previous games
   			If Credits>0 then
  				LightCredit.State=1
  				For Each Light in CreditLight
  					Light.State=1
  				Next
   			end if
   			
   			CreditReel() ' Display the current number of credits
   			
			For each reel in LED1 ' turns ON the last number in the reel
  				Reel.SetValue( 1 )
  			next 
  			
  			EMReel31.SetValue(1) ' displays a "0" in ball box reel
  			EMReel32.SetValue(1) ' same
  			reeloff=0 ' resets reel match countdown effect
  		case 2
  				NewBall() ' start the process and kick out a ball for the first player
  		case 3
  			' This is the call to start the bonus count after that "pause" from a drain
  			TimerBonus.Enabled = True
  		case 4
  			' after the match delay
  			GetMatch()
		case else ' anything other than listed as a case number, just exit
			Exit sub
			
	end select
	
	GetTimerControlCode=0 ' reset this back to 0 to prevent any possible errors.
	
end sub


'********************************************
' *** Key Up / Key Down Section / Menus ***
'********************************************
' This section holds the code that determines what happens when you press a key on your keyboard.

Sub Table_KeyDown(ByVal keycode)

	Dim RulesText ' Temp Variable for Rules box
	' call's plunger hook as well for custom plunger
	If keycode = PlungerKey Then 
		SetPlungerKeyPullback() ' *** HOOK ***
		Plunger.PullBack
		PlaySound "RustyPlunger"
	end if
' Only allow the flippers to work if the game is not over and we are not tilted
	If gameover = False And tilt = False Then
		If keycode = LeftFlipperKey Then
			LeftFlipper.RotateToEnd				' Flipper "Up"
			'ShiftLanesLeft					' For 1-2-3-4-5 lanes
			PlaySound "FlipperUp"				' Play a sound
			SetLeftFlipperKeyDown() ' *** HOOK ***
		End If
			
		If keycode = RightFlipperKey Then
			RightFlipper.RotateToEnd			' Flipper "Up"
			'ShiftLanesRight					' For lanes
			PlaySound "FlipperUp"				' Play a sound
			SetRightFlipperKeyDown() ' *** HOOK ***
		End If
	End If

' Nudge keys

	If keycode = LeftTiltKey Then 					' We nudged the table so
		Nudge 90, 2 						' Nudge the table
        newtilt = 1 							' Set the nudge direction
        TiltCheck() 							' See if we tilted
	End If
    
	If keycode = RightTiltKey Then
		Nudge 270, 2
        newtilt = 2
        TiltCheck()
	End If
    
	If keycode = CenterTiltKey Then
		Nudge 0, 2
        newtilt = 3
        TiltCheck()
	End If
	
	If keycode = 19 then ShowRules():ShowScoring():end if ' R key for rules 
	If keycode = 61 then SystemMenu():end if ' F3 key
	
' Credit/Start keys

    If keycode = AddCreditKey Then 	' A coin was inserted ('5' key or whatever key set)
    	
    	' we stop the sounds in case it's still playing when another player is added
    	StopAllSounds() ' stops all sounds
    	
    	' you can change the sound, just keep the same file name, or just delete it if you 
    	' don't want the sound to play
    	PlaySound "CoinIn"' Play the mechanical coin sound
    	PlaySound "CoinIn2"' Play the eletronic coin sound
    	
    	' we use the same code in GetSpecial() to check for replays, match, and specials,but we 
    	' don't want the sound, so we just duplicate the code we need here.
		credits = credits + 1 				' Add 1 to the total credits
        If credits > MaxCredits Then credits = MaxCredits ' But don't let us go over max credits
        ' Turn on Credit light
       	LightCredit.State=1
 		For Each Light in CreditLight:Light.State=1 : Next
 		
        CreditReel()' Display the new credit total. This sub also calls savehs() to save
    End If
    
    If keycode = StartGameKey Then ' Start button is pressed ('1' key or whatever key set by user)
       If credits > 0 and TimerControl.enabled=0 Then ' If we have credits, and sound timer off
          If players < 4 Then 						' And there is not already 4 players
             If Started = False Then 					' And player 1 has not started yet
             	
                players = players + 1					' Add a player
                player = 1 						' Player 1 is up
                gameover = False 					' then start a new game
                
             ' Initialize the table only once, and blank the display. we blank it here because
             ' This will happen only with the first player, that way, the display won't blank when
             ' P2> are added.
             	If players = 1 Then ResetTable():SetBlankDisplay():end if
			' This turns on a zero in the player score display so people know new players 
			' are added
           		ResetReel1()
			' Handle credits/sounds       
                credits = credits - 1 ' eat a credit for the game
                CreditReel()' Display the new credit total. This sub also calls savehs() to save
 				StopAllSounds() ' stops all sounds
				PlaySound "GameStart"
				
 				' this calls the delay, and plays the opening game sound with a simple
 				' timer, before the ball pops out to start play. The interval for the delay
 				' is set in table_init using GameStartInterval
 				If Players=1 then SetTimer 2
             
             If Credits<1 then ' No credits, so switch off lights
				LightCredit.State=0
 				For Each Light in CreditLight:Light.State=0 : Next
 			end if
             ResetBonus()
             End If
          End If
       End If
    End If 
       	    
	If keycode = 210 then 
		For Each target in DebugWalls
     		target.IsDropped = 0
 		Next
	end if
	
	' (Delete Key)(Cheater post down)
	If keycode = 211 then
		For Each target in DebugWalls
     		target.IsDropped = 1
 		Next
	end if
   
End Sub 

' *******************************************
' This is what happens after you let go of a keypress.

Sub Table_KeyUp(ByVal keycode)

	If keycode = PlungerKey Then 
		Plunger.Fire
		PlaySound "PlungerSpring"
		SetPlungerKeyFire() ' *** HOOK ***
	end if

	If gameover = False Then ' Turn off the flippers if the game is over
		If keycode = LeftFlipperKey Then			
			LeftFlipper.RotateToStart				' Flipper down
			if tilt=0 then PlaySound "FlipperDown" ' Play a sound, but not if it's tilted
			SetLeftFlipperKeyUp() ' *** HOOK ***
		End If
    
		If keycode = RightFlipperKey Then
			RightFlipper.RotateToStart				' Flipper down
			if tilt=0 then PlaySound "FlipperDown" ' Play a sound, but not if it's tilted
			SetRightFlipperKeyUp() ' *** HOOK ***
		End If
	End If

End Sub 

Sub SystemMenu()
		MsgBox TableName + vbCRLF +_
 		AuthorName + vbCRLF +_
 		"System Menu" + vbCRLF +_
 		vbCRLF +_
 		vbCRLF +_
 		"First replay: " & "" & Goal1 & + vbCRLF +_
 		"Second replay:" & "" & Goal2 & + vbCRLF +_
 		"High Score" & ": " & highscore & + vbCRLF +_
 		"Credits" & ": " & credits & + vbCRLF +_
 		"Balls Per Game" & ": " & balls & + vbCRLF +_
 		"5 - Add one credit" + vbCRLF +_
 		"1 - Start game/Add Player" + vbCRLF +_
 		"shift - flippers" + vbCRLF +_
 		"Enter - plunger" + vbCRLF +_
 		"z, /, spacebar - nudge table" + vbCRLF +_
 		"1 - Start game/Add Player" + vbCRLF +_
 		"", _
 		vbOkOnly, TableName

end sub 

' Rather than just write a lot of StopSounds when we use the TimerControl_Timer or other
' subs, we just pop them all in here, and point to them as a sub call. A lot easier this
' way, and it's handy for your code as well, because it does sound terrible if you have
' multiple sounds playing at once. This uses the stock eletronic sounds, the mechanical 
' sounds will still play. The Background sound you will have to turn off if you want in
' your code.
Sub StopAllSounds()
	StopSound "BallLaunched":StopSound "BallSaverMade":StopSound "BallStart":StopSound "Bonus":
	StopSound "Bumper2":StopSound "ButtonOff":StopSound "ButtonOn":StopSound "CoinIn2"
	StopSound "GameEnd":StopSound "GameStart":StopSound "MatchMade"
	StopSound "MatchStart":StopSound "RolloverOff":StopSound "RolloverOn":StopSound "Sling2"
	StopSound "TablePowerOn":StopSound "TableStart":StopSound "Target"
	StopSound "TargetBank":StopSound "Tilt":StopSound "YouTilt"
end sub

			Rem ********************************************
			Rem ********************************************
			Rem ***    Score Event Subroutines           ***
			Rem ********************************************
			Rem ********************************************
							
REM This contains the common subroutines that you can just point to in your code

'Add a Credit

Sub GetSpecial()
	If tilt = 0 then ' check to make sure we are not tilted first
            credits = credits + 1 				' Add 1 to the total credits
            PlaySound "Knocker" 				' Make some noise
            If credits > MaxCredits Then credits = MaxCredits ' But don't let us go over max credits
            ' Turn on Credit light
       		LightCredit.State=1
 			For Each Light in CreditLight:Light.State=1 : Next
            CreditReel() 					' Display the new credit total
	End if           
End Sub

' Add a Extra Ball

Sub GetExtraBall()
	If tilt = 0 then ' check to make sure we are not tilted first
		extraball = True
		If GetScoreBells=1 then PlaySound "ExtraBall":End if
		LightEB.State = 1
	end if
End Sub


			Rem ********************************************
			Rem ********************************************
			Rem ***          HIT EVENT SECTION           ***
			Rem ********************************************
			Rem ********************************************
' This code handles all of the routines for when the ball hits an object on the table. 
' This section is usually the largest. This also includes the Timers for some of these routines

' Puts a new ball into play
' This is the main routine for the start of each new ball

Sub NewBall()

	BallSaver = True				' if BallSave timer times out will reset to false		
' Light control
	
	For Each Light in HSLight:Light.State=0 : Next ' Turn Off High Score Light (On First Ball)	
	For Each Light in TiltLight:Light.State=0 : Next ' Turn off the tilt light if it was on

'Multiball Code
	Multiball = 1 					' Resets with multiball on table
	Ballcount = Ballcount + 1 			' Adds ball & multiball
	Ballcount = 2
	OverflowScore=0

' Check ball in play
	If extraball = False Then
   		player = player + 1 			' Increment to the next player
   	If player > players Then 			' If all players have played the same ball
      	player = 1 					' Go back to player 1
      	ball = ball + 1 				' and play the next ball
   	End If   
	End If

	If extraball = True Then 			' Handle the extra ball when we have one
   		extraball = False 			' We are using the extra ball so this becomes false now
	   	LightEB.state = 0 ' turn off the extra ball light
	End If
	
	If ball < (balls + 1) Then 			' If we haven't played all balls then play another
   		Trough_Init()
	End If

	If ball = (balls + 1) Then 			' If we have played all balls then end the game
		Drain.DestroyBall ' Destroys ball
		'StartLastBallLost() ' *** HOOK ***
   		BallCount = 0 				' Clear value
		Multiball = 0 				' Clear value
		' Calls delay timer to delay Match Countdown, in case you want a sound here. Once
		' that timer is finished (set by MatchStartInterval in table_init) then it calls
		' the GetMatch() sub to start the match
		SetTimer 4 

	End If
	
End Sub ' End of Sub NewBall

' This kicks out the next ball
' No need to change this

Sub Trough_Init()

	If gameover = False Then 					' But only if the game is not over
		BallCount = BallCount - 1 				' Loose 1 ball
		Multiball = Multiball - 1 				' Loose multiball
		
		' Now we reshow the scores, in case of a tilt, as a tilt blanks all the displays
   		' so we cheat and call the score routine (which updates the score) but we tell it
   		' to update the score by adding zero to the score.
   		For y = 1 To 4
    		SetLEDs y - 1, score( y )
    	Next
   		BallReel() ' Update the ball display
   		CreditReel() ' Display the new credit total
   		
   		' If we tilted, we need to put the "1"'s display back on. This looks at the amount
   		' of players. It's not pretty, but then it works
   		ResetReel1()
   		
	' Multiball Code, makes sure that it doesn't count bonus if lose of first multiball, note this is in the first If/Then/Else statement	
		If Multiball = 0 Then 						' If not Multiball
			MultiBall = MultiBall + 1
			MultiplierLight() ' sets multiplier light
			MemoryLoad() ' call the memory system for that player
			SetNewBall() ' *** HOOK *** 
			
			' Now we need to restore the script if we are in a tilted state
			Tilt = 0 ' Reset the tilt state if we are tilted
			
			' show the players scores, we need to do this after a tilt
			For y = 1 To 4
    			SetLEDs y - 1, score( y )
    		Next
    		
    		' We need to indicate the player up, so first we turn off all the player lights
    		For x = 1 to 4
    			PlayerLight(x).State = 0
    		next
    		
    		' Light the player light
    		PlayerLight(player).State = 1
    		
    		' This starts the flashing display for the player
			seFlashDisplay = 1
   			TimerFlashDisplay.Enabled = 1 ' start flashing display
   			
   			' now we start the ball, and pop it out to the plunger lane
			Trough.CreateBall
			PlaySound "Trough" ' just a sound, you can replace or delete this in Tables/Sound Manager Menu
   			Trough.kick 60, 5 ' Kick out the ball
   			x = 0
   			seBallInTrough=0 ' indicate ball out of trough

		End If  
	End If	
End Sub

Dim HoldEndOfBall ' variable to use if we want to delay the bonus count setup so 
' we have the time to execute custom code
Sub Drain_Hit() ' We lost the ball

	Drain.DestroyBall ' so get rid of it
	seBallInTrough=1 ' set variable to indicate a ball is in trough (for tilt)
	PlaySound "Drain" ' just a sound, you can replace or delete this in Tables/Sound Manager Menu
	BallCount = BallCount - 1 		' loose 1 ball
	Multiball = Multiball - 1 		' loose multiball	
	LightBallSaver.State = 0		' Switch LightBallSaver Off
	Drained = True
	MemorySave()
	If Multiball = 0 Then
		MultiBall = MultiBall + 1
		If Tilt = True Then			'Checks if We Tilted
			ResetBonus()			'Resets Bonus & Bonus Lights
		End If
' If ball was in play < than time set and wasn't already a BallSaver replay, replay same ball
' But make sure you had not tilted first
' We switched off the BallSaver light at the main tilt routine
		If tilt = False And BallSaver = True And ReplayBall = False Then
			ReplayBall = True
       		ExtraBall = True
    	Else							' We tilted!
    		ReplayBall = False
    		TimerBallSaver.Enabled = False 
    	End If	
	End If
	SetBallLost() ' *** HOOK ***
	If HoldEndOfBall=0 then GetEndofBallBonus()
end sub
		
Sub GetEndofBallBonus()	

' After we checked for the BallSaver, we now start the Bonus Countdown
' Note we still check to make sure we haven't tilted    
 
 		If tilt = False and TimerBallSaver.Enabled = False and Multiball=1 Then ' If we haven't tited!
 			StopAllSounds() ' make sure sounds off
 			
 	   	' And start the end of ball bonus count. The BonusTimerIntervalStart is a HOOK that
 	   	' is adjustable by the user. This sets the initial interval time between bonus counts
 	   		HoldBonus = Bonus
 	   		TimerBonus.Interval = BonusTimerIntervalStart
 	   		 
 	   	' This calls that "pause" set by the DrainDelayInterval variable in Table_Init()
 		' this delays the bonus count untill after the timer interval is over, and is
 		' used for that delay in older games, or to play a "opening sound" like System9
 		' games such as Sorcerer does before it counts down the bonus
 		' The bonus timer is set to start at the end of this timer
 			SetTimer 3	

    	Else ' Or we did tilt
 	   		NewBall()' No countdown, just go to NewBall sub
		End If
	
End Sub ' End of Sub Drain_Hit

'*** Flashing Display ***

' This flashs the players score on and off at the start of each ball. It's turned off at
' LaunchTrigger_Hit() and of course at a tilt and end of ball. Just a simple timer that
' repeats itself untill switched off in the code. You can set the interval time in the
' editor, default is 500

Dim seFlashDisplay ' variable to control "on/off"

Sub TimerFlashDisplay_Timer()

    If seFlashDisplay = 0 Then 
    	If Player=1 Then EMReel22.SetValue( 0 )
		If Player=2 Then EMReel15.SetValue( 0 )
		If Player=3 Then EMReel1.SetValue( 0 )
		If Player=4 Then EMReel8.SetValue( 0 )
       	SetLEDs player - 1, 0
    else
    	SetLEDs player - 1, score( player )
    	If Player=1 Then EMReel22.SetValue( 1 )
		If Player=2 Then EMReel15.SetValue( 1 )
		If Player=3 Then EMReel1.SetValue( 1 )
		If Player=4 Then EMReel8.SetValue( 1 )
    end if
    
    seFlashDisplay = (seFlashDisplay + 1) Mod 2
    
End Sub

' Switchs off the BallSaver feature after it is called at the start of each NewBall

Sub TimerBallSaver_Timer
	
	TimerBallSaver.Enabled = False
	BallSaver = False ' Set flag to indicate ball saver finished
	LightBallSaver.State = 0 ' Stop light blinking to indicate BallSaver period has expired
	
End Sub	' End of Sub BallSaverTimer_Timer

' *** TRIGGERS ***
' *** 1-2-3-4-5 and Ramp Loop ***
'
' This is for the Hit events for the 1-2-3-4-5 rollovers
' As well as the Ramp Loop Bonus triggers 
' Also, the left and right inner lanes control the ramp loop bonus as well

' We use this gate just for the ball start sound. Polish more than anything. If you replace this
' sound with a custom sound, just make sure the file name is the same, 
' as the LaunchTrigger() sub will automatically switch it off

Sub TriggerTrough_Hit()
	PlaySound "BallStart"
end sub

Sub LaunchTrigger_Hit()
	
' Now we do the start up code, for the engine to reconize that a ball is in play.
    Started = True ' Disallows adding players once the first ball has been launched

' Prevent BallSaver after previous BallSaver. Because we ponied up the code, the timer will
' still be active even on a weak shot, but simplier coding = less problems
	
	If ReplayBall = False And Drained = True Then 
		Drained = False					' To show this is a NEW ball, not a mulitball or BallSaver replay ball
		TimerBallSaver.Interval = BallSaverTimeInterval ' Ensures timer gives the time set in Init
		TimerBallSaver.Enabled = True
		LightBallSaver.State = 2 			' indicate within BallSaver time, but not on a BallSaver replay 
	End If


End Sub

			Rem ********************************************
			Rem ********************************************
			Rem ***         Scoring Section              ***
			Rem ********************************************
			Rem ********************************************

' This section handles the adding up of the players score, bonus, and bonus multiplier
' You also check for events such as the awarding of a replay and counting the end of ball bonus.

' There's 2 separate scoring systems, this one, which will just add the score imediately
' and the AddScore sub, which is used for the bally display effect, which "counts up" the
' points being added.

' To use this: Getscore 100
Sub GetScore (ScoreToAdd) ' collect the points for doing something

	If tilt = False Then 							' But not if we are tilted
    	If gameover = False Then 					' And not if the game is over
    		TimerFlashDisplay.Enabled = 0 ' Turn off the flashing display
	       score(player) = score(player) + ScoreToAdd ' Add the points to our score
	     
	       SetLEDs player - 1, score( player )          ' Display the new score
	       If score(player) > goal1 Then 				' Check to see if we have enough for the first replay
	       		If made1(player) = False Then 			' If we do check to see if we got it already
	        	made1(player) = True				' If we didn't then collect it
	            GetSpecial() 					' Add 1 to our credits
	       		End If
	       End If
			
       		If score(player) > goal2 Then 					' Same as above except for making the second replay score
          		If made2(player) = False Then
             		made2(player) = True
             		GetSpecial()
             	End If
       		End If
    	End If
	End If

End Sub

' Bally type display
' we have to do a lot of variables here
Dim Ones
Dim Tens
Dim Hundreds
Dim Thousands
Dim TenThousands
Dim HundredThousands
Dim Millions


Dim Value ' this is the points value you want to add to the player score.
Dim OverflowScore ' variable to hold points if the display is busy already counting
Dim GetScoreBells


' Main routine, this controls the "count" effect
Sub AddScore(Value)

' First thing we check is to see if the display is actually counting first. If so, then
' we store the additional points to be counted directly afterwards. If we don't do this
' then we lose that extra score value
	If ScoreDelay.TimerEnabled Then 
		OverflowScore=OverflowScore+Value ' we check this at the timer after it's finished
		Exit Sub ' Leave this sub as the timer is busy
	end if
	
	' now we look at the Value to be added. If you notice, we divide that number, and
	' then use that number to control how many counts to do. So a value of 600 will 
	' end up being "6" in the Hundreds line. This means in the timer call afterward 
	' that "hundreds" = 6, and the display will count 6 times, adding 100 points each count.
	
	'Adds the ones
	If Value<10 Then 
		Ones=Ones+Value 
	end if
	'Adds the 10's
	If Value>9 And Value<100 Then 
		Tens=Tens+(Value\10)
	end if
	'Adds the 100's	
	If Value>99 And Value<1000 Then
		Hundreds=Hundreds+(Value\100)	
	end if
	'Adds the 1000's
	If Value>999 And Value<10000 Then
		Thousands=Thousands+(Value\1000) 
	end if
	'Adds the 10000's
	If Value>9999 And Value<100000 Then
		TenThousands=TenThousands+(Value\10000)
	end if
	'Adds the 100000's
	If Value>99999 And Value<1000000 Then
		HundredThousands=HundredThousands+(Value\100000)
	end if
	'Adds the 10000's
	If Value>999999 Then
		Millions=Millions+(Value\1000000)
	end if
	
	' now go to the timer to count
	ScoreDelay.TimerEnabled=True							'Start the scoring
	
End Sub

Sub ScoreDelay_Timer 'Timer used for the motor simulator. I am using the built-in timer for a wall.

	' Now we take that number generated, and do the count. The interval can be set in the
	' ScoreDelay object (It's a locked wall to the left of the table)
	' So what this does is take the number, add the score and decrease the count by one.
	' It then runs the interval, and loops back and start over, until the count is 0
	' We also have our sound system tied into this routine, using the GetScoreBells variable.
	' If the value is "1", then the system will automatically play the assigned sound for 
	' EACH count. if the value is set to "0", then it won't play the sounds, you will have
	' to add your own sound code within your hit code.
	StopSound "Bell1":StopSound "Bell10":StopSound "Bell100":StopSound "Bell1000":
	If Ones>0 Then
		GetScore 1:Ones=Ones-1'Add 1 to score, subtract 1 from counter
		If GetScoreBells=1 then Playsound "Bell1":end if
	end if
		 
	If Tens>0 Then 
		GetScore 10:Tens=Tens-1
		If GetScoreBells=1 then Playsound "Bell10":end if
	end if
				
	If Hundreds>0 Then 
		GetScore 100:Hundreds=Hundreds-1
		If GetScoreBells=1 then Playsound "Bell100":end if
	end if
	
	If Thousands>0 Then 
		GetScore 1000:Thousands=Thousands-1
		If GetScoreBells=1 then Playsound "Bell1000":end if
	end if
	
	If TenThousands>0 Then 
		GetScore 10000:TenThousands=TenThousands-1
		If GetScoreBells=1 then StopSound "Bell10000":Playsound "Bell10000":end if
	end if
	
	If HundredThousands>0 Then
		GetScore 100000:HundredThousands=HundredThousands-1
		If GetScoreBells=1 then StopSound "Bell100000":Playsound "Bell100000":end if
	end if
	
	If Millions>0 Then
		GetScore 1000000:Millions=Millions-1
		If GetScoreBells=1 then StopSound "Bell1000000":Playsound "Bell1000000":end if
	end if
	
	' Now we see if the count is 0
	If Ones+Tens+Hundreds+Thousands+TenThousands+HundredThousands+Millions=0 Then
		Me.TimerEnabled=False 'If nothing left, then exit timer
		
		' And now we check to see if there were any values to be added while the timer
		' was going. then we just loop back and restart the entire process with the new
		' value
		If OverflowScore>0 then
			Value = OverflowScore
			OverflowScore=0
			Addscore (Value)
		end if
			
	End If
	
End Sub

' Controls the player displays

Dim Number ' used to set number value so we know which reel needs to be used in a score
Dim reel ' used for collections

' This is separate, as it's used by several subroutines. This just restores the "1"'s
' to the reel display. It's mainly for the tilt routine, in case a player tilts when he
' has no score

Sub ResetReel1()
	If Players = 1 Then EMReel22.SetValue( 1 ):end if
	If Players = 2 Then EMReel22.SetValue( 1 ):EMReel15.SetValue( 1 ):end if
	If Players = 3 Then 
		EMReel22.SetValue( 1 ):EMReel15.SetValue( 1 ):EMReel1.SetValue( 1 )
	end if
	If Players = 4 Then 
		EMReel22.SetValue( 1 ):EMReel15.SetValue( 1 )
		EMReel1.SetValue( 1 ):EMReel8.SetValue( 1 )
	end if
End sub

' Controls the reels themselves, and handles the actual score display
Sub SetLEDs( scoreel, number )

	' displays the first zero in the reel. This is after a Flashing display timer event
	' or you will get the first number as blank.
	
	ResetReel1()
	If Number > 0 Then 
		LED1( scoreel ).SetValue( Int( ( number Mod 10 ) / 1 ) + 1 )
	Else
		LED1( scoreel ).SetValue( 0 )
	End If
	       	
	If Number > 9 Then 
		LED2( scoreel ).SetValue( Int( ( number Mod 100 ) / 10 ) + 1 )
	Else
		LED2( scoreel ).SetValue( 0 )
	End If
		
	If Number > 99 Then
		LED3( scoreel ).SetValue( Int( ( number Mod 1000 ) / 100 ) + 1 )
	Else
		LED3( scoreel ).SetValue( 0 )
	End If
	
	If Number > 999 Then
		LED4( scoreel ).SetValue( Int( ( number Mod 10000 ) / 1000 ) + 1 )
	Else
		LED4( scoreel ).SetValue( 0 )
	End If
	
	If Number > 9999 Then
		LED5( scoreel ).SetValue( Int( ( number Mod 100000 ) / 10000 ) + 1 )
	Else
		LED5( scoreel ).SetValue( 0 )
	End If

	If Number > 99999 Then
		LED6( scoreel ).SetValue( Int( ( number Mod 1000000 ) / 100000 ) + 1 )
	Else
		LED6( scoreel ).SetValue( 0 )
	End If
	
	If Number > 999999 Then
		LED7( scoreel ).SetValue( Int( ( number Mod 10000000 ) / 1000000 ) + 1 )
	Else
		LED7( scoreel ).SetValue( 0 )
	End If
	
 End Sub
 
' This sub is separate, and we use to blank the display at Table start and game end, as
' well as the attract mode
Sub SetBlankDisplay()
	For each reel in LED1:Reel.SetValue( 0 ): next
    For each reel in LED2:Reel.SetValue( 0 ): next
    For each reel in LED3:Reel.SetValue( 0 ): next
    For each reel in LED4:Reel.SetValue( 0 ): next
    For each reel in LED5:Reel.SetValue( 0 ): next
    For each reel in LED6:Reel.SetValue( 0 ): next
    For each reel in LED7:Reel.SetValue( 0 ): next
    For Each Light in HSLight:Light.State=0 : Next ' Turn off the high score light
end sub


'********************************************
'***  Bonus Routine ***

Sub AddBonus() ' add 1k bonus to the bonus counter and change the lights
' The control routine for adding a bonus to your score
' Note the two variables, the "x" handles the 10 and 20 lights
' The "y" variable is for the 1 to 9 lights
    
	HoldBonus = Bonus						'Holds Bonus in another variable for BonusCount by Mult
    bonus=bonus + 1							'This increases Bonus by one
    ' Forced Bonus Value set by user, if it goes over, then it adds the bonus points value set by the user automatically
     If bonus > BonusCountMax Then bonus = BonusCountMax:addscore (BonusAmount):End If
    AddBonusLights()							'Calls sub in RESET AND CHECKING section
    
End Sub ' end sub AddBonus()

' *** Bonus Multiplier ***

Dim MaximumBonusMultiplier ' sets the maximum amount for the multiplier (15x max)

  ' *** multiplier value ***
Sub AddMultiplier()

 	mult=mult+1
     'Switch off mult lights first, so we just need to turn on the lights we want in the case setting 
     For z = 1 To 5 : eval("Light" & z & "x").State = 0: Next
     If mult > MaximumBonusMultiplier Then 
     	mult = MaximumBonusMultiplier
     End If ' Forced Bonus Value set by user
     
     ' Now we add the light for the multiplier. We split this to a new subroutine in case you 
     ' need to refresh the multiplier lights in your code, but don't want to add a new 
     ' multiplier.
     
 	MultiplierLight()
 	' sound and lights, also handles if bonus multiplier is at max. 
End Sub

' turn on the proper light to match the multiplier value
 Sub MultiplierLight()
 	Select Case mult
 		Case 15:For z = 1 To 5 : eval("Light" & z & "x").State = seBLightState: Next '15x
 		Case 14:Light5x.State=seBLightState:Light4x.State=seBLightState:Light3x.State=seBLightState:Light2x.State=seBLightState '14x
 		Case 13:Light5x.State=seBLightState:Light4x.State=seBLightState:Light3x.State=seBLightState:Light1x.State=seBLightState '13x
 		Case 12:Light5x.State=seBLightState:Light4x.State=seBLightState:Light3x.State=seBLightState '12x
 		Case 11:Light5x.State=seBLightState:Light4x.State=seBLightState:Light2x.State=seBLightState '11x
 		Case 10:Light5x.State=seBLightState:Light4x.State=seBLightState:Light1x.State=seBLightState	'10x
 		Case 9:Light5x.State=seBLightState:Light4x.State= seBLightState'9x
 		Case 8:Light5x.State=seBLightState:Light3x.State=seBLightState '8x
 		Case 7:Light5x.State=seBLightState:Light2x.State=seBLightState '7x
    	Case 6:Light5x.State=seBLightState:Light1x.State=seBLightState '6x
       	Case 5:Light5x.State=seBLightState '5x
    	Case 4:Light4x.State=seBLightState '4x
    	Case 3:Light3x.State=seBLightState '3x
 	  	Case 2:Light2x.State=seBLightState '2x
    	case 1:Light1x.State=seBLightState '1x
    End Select
end sub

' Counts multiplier, note the light values are ONE less than the mult
 Sub TAdvMultCount()
 	If mult > MaximumBonusMultiplier Then mult = MaximumBonusMultiplier:End If ' Forced Bonus Value set by user
 	'Switch off mult lights first, so we just need to turn on the lights we want in the case setting 
     For z = 1 To 5 : eval("Light" & z & "x").State = 0: Next
     ' check for mult, add lights
     If mult = 15 then 
 	    For z = 1 To 5 : eval("Light" & z & "x").State = 1: Next
     End If
	If mult = 14 then Light5x.State = 1:Light4x.State = 1:Light3x.State = 1:Light2x.State = 1:AddBonusLights():End If
	If mult = 13 then Light5x.State = 1:Light4x.State = 1:Light3x.State = 1:AddBonusLights():End If
	If mult = 12 then Light5x.State = 1:Light4x.State = 1:Light2x.State = 1:AddBonusLights():End If
	If mult = 11 then Light5x.State = 1:Light4x.State = 1:Light1x.State = 1:AddBonusLights():End If
	If mult = 10 then Light5x.State = 1:Light4x.State = 1:AddBonusLights():End If
	If mult = 9 then Light5x.State = 1:Light3x.State = 1:AddBonusLights():End If
	If mult = 8 then Light5x.State = 1:Light2x.State = 1:AddBonusLights():End If
	If mult = 7 then Light5x.State = 1:Light1x.State = 1:AddBonusLights():End If
 	If mult = 6 then Light5x.State = 1:AddBonusLights():End If
	If mult = 5 Then Light4x.State = 1:AddBonusLights():End If
	If mult = 4 then Light3x.State = 1:AddBonusLights():End If
	If mult = 3 Then Light2x.State = 1:AddBonusLights():End If
 	If mult = 2 Then Light1x.State = 1:AddBonusLights():End If
 	If mult = 1 then AddBonusLights():End If		
 	mult = mult - 1
 End Sub



' This routine checks for the multiplier, and calls the TAdvMultCount to
' count by each mult value

Sub CheckMulti()

 	If mult >0 then
   		Bonus = HoldBonus
   		TAdvMultCount()						' Start a new count by Multiplier
   	End if
   		
   	If mult = 0 then
 		TimerBonus.Enabled = False 				' turn off the timer
   		ResetBonus() 
   		NewBall()  		
   	End If 
   	
End Sub ' end sub CheckMulti()

'********************************************

'*** Collect the end of ball bonus ***

Sub TimerBonus_Timer()
' Main routine for the Bonus Countdown
	
	x = Int(bonus / 10) 							' will be equal to the 10's digit
	y = bonus Mod 10 							' will be equal to the 1's digit
	BonusCounted = False 							' ensure that this is set to false before we count

' We go into this if/then section if there are any lights lit in the 1k - 9k range.
' The highest value light will be turned off and our score will be increased
' by 1000 times the multiplier value. We set the variable 'BonusCounted' to true to
' make sure that we only count once per timer cycle.

	If y <> 0 Then 		' If there are any 1k - 9k lights lit then y will not equal zero and we will proceede
   		Select Case y
   			Case 9 										' counts the 9k light
      			Light9k.State = 0				' turns off the 9k light
   			Case 8 										' counts the 8k light
      			Light8k.State = 0 			' turns off the 8k light
   			Case 7 										' counts the 7k light
      			Light7k.State = 0 			' turns off the 7k light
   			Case 6 										' counts the 6k light
      			Light6k.State = 0			' turns off the 6k light
   			Case 5 										' counts the 5k light
      			Light5k.State = 0 			' turns off the 5k light
   			Case 4 										' counts the 4k light
      			Light4k.State = 0 			' turns off the 4k light
   			Case 3 										' counts the 3k light
   		   		Light3k.State = 0 			' turns off the 3k light
   			Case 2 										' counts the 2k light
      			Light2k.State = 0 			' turns off the 2k light
   			Case 1 										' counts the 1k light
      			Light1k.State = 0			' turns off the 1k light
   		End Select
		
   		If tilt=0 then
   		
   		' we use the getscore here, so you can have a different sound if you use the 
   		' GetScoreBells chime sound system. Remember, that Bally used 2 different sounds
   		' for 1000 points, a single one note sound they used for bonus and any score that
   		' had a value of OVER 1000 (usually 5000) but they also played a multi-note sound
   		' for anything else that scored just a 1000 points. Note we use the GetScore here
   		' so we by pass the chime system with it's timers
   		
			GetScore (BonusAmount)	' adds the counted bonus to our score and times it by the multiplier
			BonusCounted = True ' we counted a 1's bonus so make sure we don't count a 10's bonus
			
		' plays a sound for each bonus. We put it here so it doesn't play a extra sound 
		' afterwards. To make timing easier, we stop the sound first, to prevent "overlap"
		' Note we use a special "bonus" sound here,so we have flexibility for 1980 plus games
		
			StopSound "Bonus":PlaySound "Bonus"
			
		else
			' we tilted, so reset the variables. This is to prevent the game giving a bonus
			' value at a titled state
			mult = 0
			bonus=0
			x = 0
			y = 0
			TimerBonus.Enabled = False 	' turn off the timer
   			ResetBonus() 
   			NewBall() 
		end if
	End If

	If x <> 0 And BonusCounted = 0 Then
    		Select Case x
    		case 16
    			seSetLightBonus1k 1:seSetLightBonus10k 1
    		case 15
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light20k.State = 1:Light30k.State = 1:Light40k.State = 1:Light50k.State = 1
    		case 14
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light10k.State = 1:Light30k.State = 1:Light40k.State = 1:Light50k.State = 1
    		case 13
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light30k.State = 1:Light40k.State = 1:Light50k.State = 1
    		case 12
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light20k.State = 1:Light40k.State = 1:Light50k.State = 1
    		case 11
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light10k.State = 1:Light40k.State = 1:Light50k.State = 1
    		case 10
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light40k.State = 1:Light50k.State = 1
    		case 9
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light30k.State = 1:Light50k.State = 1
    		case 8
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light20k.State = 1:Light50k.State = 1
    		case 7
    			seSetLightBonus1k 1:seSetLightBonus10k 0:Light10k.State = 1:Light50k.State = 1
    		Case 6
       		seSetLightBonus1k 1:seSetLightBonus10k 0:Light50k.State = 1
 		Case 5
       		seSetLightBonus1k 1:seSetLightBonus10k 0:Light40k.State=1
 		Case 4
       		seSetLightBonus1k 1:seSetLightBonus10k 0:Light30k.State = 1
 		Case 3
       		seSetLightBonus1k 1:seSetLightBonus10k 0:Light20k.State = 1
 		Case 2
       		seSetLightBonus1k 1:seSetLightBonus10k 0:Light10k.State = 1
 		Case 1
       		seSetLightBonus1k 1:seSetLightBonus10k 0
    		End Select   	

		BonusCounted = 1
		If tilt=0 then
		
		' we use the getscore here, so you can have a different sound if you use the 
   		' GetScoreBells chime sound system. Remember, that Bally used 2 different sounds
   		' for 1000 points, a single one note sound they used for bonus and any score that
   		' had a value of OVER 1000 (usually 5000) but they also played a multi-note sound
   		' for anything else that scored just a 1000 points.
   		
			GetScore (BonusAmount) ' adds the counted bonus to our score
			
		' plays a sound for each bonus. We put it here so it doesn't play a extra sound 
		' afterwards. To make timing easier, we stop the sound first, to prevent "overlap"
		
			StopSound "Bonus":PlaySound "Bonus"
		else
			' we tilted, so reset the variables. This is to prevent the game giving a bonus
			' value at a titled state
			mult = 0
			bonus=0
			x = 0
			y = 0
			TimerBonus.Enabled = False 	' turn off the timer
   			ResetBonus() 
   			NewBall() 
		end if 
	End If

	bonus = bonus - 1 ' subtract the bonus we just counted from the total bonus
	' subtract time for each count set by BonusTimerIntervalStart (set by user in Init)
	' and then we use the BonusTimerIntervalDecreaseBy variable to decrease that interval
	' time for the next count.
	TimerBonus.Interval = TimerBonus.Interval - BonusTimerIntervalDecreaseBy 
	' Make sure the count is not less than 20 milliseconds
	If TimerBonus.Interval <= 20 then TimerBonus.Interval = BonusTimerIntervalMinimumTime 	
	If x = 0 And y = 0  Then 						' If we have counted all bonus
   		CheckMulti							' Check here to start next count by Muliplier
	End If

End Sub ' End of Sub BonusTimer_Timer

' bonus lights
 'This is seperated for the Bonus Count Routine, so we don't have to keep repeating the same code
 Sub seSetLightBonus1k(State)
 	For z = 1 To 9 : eval("Light" & z & "k").State = State: Next
 End Sub
 
 Sub seSetLightBonus10k(State)
 	Light10k.State = State:Light20k.State = State:Light30k.State = State:Light40k.State = State:Light50k.State = State
 End Sub
 
' This resets the Bonus lights for the start of each new ball in play
' Multiplier lights turned off when TAdvMultCount() called at BonusTimer_Timer() sub

Sub ResetBonus()

    For z = 1 To 9 : eval("Light" & z & "k").State = 0: Next
 	Light10k.State = 0:Light20k.State = 0:Light30k.State = 0
 	Light40k.State = 0:Light50k.State = 0
 	For z = 1 To 5 : eval("Light" & z & "x").State = 0: Next
	Light1k.State = 1 						
    mult = 1 ' Resets Multiplier to 1    
    bonus = 1 ' Reset Bonus Count to 1
    
End Sub ' End of Sub ResetBonus

'********************************************
' Bonus Light routine, for light control during Bonus Countdown
' Called by AddBonus Sub and BonusCollect sub

Dim xb
Dim yb

Sub AddBonusLights() 
    
    xb = Int(bonus/10) ' 10's bonus digit
 	yb = bonus Mod 10  ' 1's bonus digit
 	' Turn off the lights
     If yb = 0 Then seSetLightBonus1k 0:seSetLightBonus10k 0:End If
 	' This makes sure the proper light is turned on with the proper bonus    
     If yb >=1 Then Light1k.State = seBLightState
     If yb >=2 Then Light2k.State = seBLightState
     If yb >=3 Then Light3k.State = seBLightState
     If yb >=4 Then Light4k.State = seBLightState
     If yb >=5 Then Light5k.State = seBLightState
     If yb >=6 Then Light6k.State = seBLightState
     If yb >=7 Then Light7k.State = seBLightState
     If yb >=8 Then Light8k.State = seBLightState
     If yb =9 Then Light9k.State = seBLightState
     Light10k.State = 0:Light20k.State = 0:Light30k.State = 0:Light40k.State = 0:Light50k.State=0
 	' This makes sure the proper "10" light is turned on with the proper bonus    
     If xb=1 Then Light10k.State = seBLightState
     If xb=2 Then Light20k.State = seBLightState
     If xb=3 Then 
     ' This has to be added for early Bally games, as though they gave 39 bonus max, they
     ' didn't have a 30k light (They lit 10 and 20 lights instead)
     	If StyleNumber < 4 then
     		Light20k.State = seBLightState
     		Light10k.State = seBLightState
     	else
     		Light30k.State = seBLightState
     	end if
     end if
     If xb=4 Then Light40k.State = seBLightState
     If xb=5 Then Light50K.State = seBLightState
     If xb=6 Then Light10k.State = seBLightState:Light50K.State = seBLightState
     If xb=7 Then Light20k.State = seBLightState:Light50K.State = seBLightState
     If xb=8 Then Light30k.State = seBLightState:Light50K.State = seBLightState
     If xb=9 Then Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=10 Then Light10k.State = seBLightState:Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=11 Then Light20k.State = seBLightState:Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=12 Then Light30k.State = seBLightState:Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=13 Then Light10k.State = seBLightState:Light30k.State = seBLightState:Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=14 Then Light20k.State = seBLightState:Light30k.State = seBLightState:Light40k.State = seBLightState:Light50K.State = seBLightState
     If xb=15 Then seSetLightBonus10k 1
    
End Sub ' End of Sub AddBonus

'********************************************

		Rem *******************************************************
		Rem *******************************************************
		Rem ***  Display, Match, Attract, File and Tilt Section ***
		Rem *******************************************************
		Rem *******************************************************
Rem This code handles the end of game match (Lucky Number) and then handles the table's attract mode
Rem (or whatever it does when the game is not in progress). It also takes care of checking and tilting the
Rem table when the player gets too rough.

Rem This code handles the text display for things like the credits and the ball in play.

' Credit display

Sub CreditReel()
	' Set the two reels for the credit display
	' Note: the credits are saved to the text file here, so everytime you get a reply/match high score
	' you don't lose the value if you leave the game
	EMReel29.SetValue( ( credits Mod 10 ) + 1 )
 	EMReel30.SetValue( Int( credits / 10 ) + 1 )
 	savehs() ' Save the special 
End Sub ' End of Sub CreditReel

' Ball in play display

Sub BallReel()
    	EMReel31.SetValue( ( Ball Mod 10 ) + 1 )
 		EMReel32.SetValue( Int( Ball / 10 ) + 1 )    
End Sub ' End of Sub BallReel

' Match display (uses Ball display reels
Sub SetMatch()
	EMReel31.SetValue( ( match Mod 10 ) + 1 )
 	EMReel32.SetValue( Int( match / 10 ) + 1 )
 End Sub
 
'********************************************
' Do the end of game match and high score check

Dim match
Dim SetMatchInterval ' holds the amount of interval time for each match count. Set by User
Dim MatchAmountOfCounts ' amount of counts for the match display before the match is shown
Dim reeloff ' Variable for the "last two numbers in score" display

Sub GetMatch()

	gameover = True 					' Set the state to game over
	For Each Light in GameOverLight:Light.State=1 : Next ' Light the Game Over light
	For Each Light in BIPLight:Light.State=0 : Next ' Turn off the ball light
	' We turn on the match lights to indicate Match started. This is a collection, so the code is simple
	' We turn on the blinking effect when a match is made.
	' Most machines only keep that match light on for a certain time afterward, so we can
	' do the same, and turn the match collection lights off in the TimerGameEnd when we restore the score
	For Each Light in MatchLight:Light.State=1 : Next ' Light match
	For Each Light in AllLights:Light.State=0 : Next ' Turn off all pf lights
	' Turns off Match reels (just looks better this way)
	EMReel31.SetValue(0)
 	EMReel32.SetValue(0)
	
' New high score check
	For z = 1 To players
    	If score(z) > highscore Then 				' Check for new high score
       		highscore = score(z) 				' Set the new high score
       		' The High score light blinks to indicate a high score. It will stop in the
       		' Attract mode. If you start a new game before then, it's turned off in New Ball sub
       		' so we don't need to worry about it.
       		For Each Light in HSLight:Light.State=2 : Next ' Hi Score Light 2 = Blinking
       		credits = credits + 3 				' Award 3 credits for making a new high score
       		If credits > MaxCredits Then credits = MaxCredits 	' Limit the total credits
       		LightCredit.State=1
       		' Turn on Credit lights
 			For Each Light in CreditLight:Light.State=1 : Next
       		PlaySound "Knocker"
       		CreditReel() 					' Display the new credit total
    	End If
	Next
	
	' We drop the flippers, and point to the Hook as well
		LeftFlipper.RotateToStart:RightFlipper.RotateToStart ' Flipper down
		SetRightFlipperKeyUp():SetLeftFlipperKeyUp() ' *** HOOK ***
	If StyleNumber=5 then
		ReelEffect() ' We use a seperate sub, to prevent interference when it does the match
		exit sub
	end if
	y = MatchAmountOfCounts:TimerMatch.Interval = MatchAmountOfCounts:TimerMatch.Enabled = True
End Sub ' End of Sub Match

sub ReelEffect()
	' Reel effect, each higher reel switches off till the last two numbers in the players score
	' shows, and then the match starts. When the match is finished, the full score is restored
	' at the Game End timer, which also clears the variables and starts the Attract mode.
	' We use the reeloff variable to keep track of each reel to switch off, and use the
	' number for the case select. reeloff is set back to 0 at ResetTable(), and game end timer for 
	' the next game
	If StyleNumber=0 or StyleNumber=5 then
		reeloff=reeloff+1
	else
		reeloff=6
	end if 
	TimerStartMatch.Interval=SetMatchInterval
	TimerStartMatch.Enabled=1
end sub


Sub TimerStartMatch_Timer()
	TimerStartMatch.Enabled=0
	Select case reeloff
	case 6:y = MatchAmountOfCounts:TimerMatch.Interval = MatchAmountOfCounts:TimerMatch.Enabled = True
	case 5:For each reel in LED3:Reel.SetValue( 0 ):next
	case 4:For each reel in LED4:Reel.SetValue( 0 ):next
	case 3:For each reel in LED5:Reel.SetValue( 0 ):next
	case 2:For each reel in LED6:Reel.SetValue( 0 ):next
	case 1:For each reel in LED7:Reel.SetValue( 0 ):next
	end select
	if reeloff < 6 then ReelEffect()
End Sub

'********************************************

Sub TimerMatch_Timer()

	match = Int( 100 * rnd ) ' we generate a number between 01 and 99
	SetMatch() 'displays the number in the match box
	

	If y = 0 Then
		Match = Int( 10 * rnd ) * 10
		SetMatch()
		TimerMatch.enabled = False
		Match2
	Else
		y = y - 1
		TimerMatch.interval = TimerMatch.interval * 1.1
		' play the match sound, we don't want the sound with the last count though
		PlaySound "Match"
	End If
	
End Sub


'********************************************
' Finish the match routine and go into attract mode

Sub Match2()
	
	For x = 1 to players ' do for all players	
	' Here we look to see if a match is made. You will notice we do this just so we can play
	' a different sound, and set a different time before the game resets and starts Attract
	' we could get real fancy, but the object is to make it as simple as possible to understand
		If Int( ( score( x ) Mod 100 ) / 10 ) * 10 = match Then 
			' A Match is made!
			credits = credits + 1 				' Add 1 to the total credits
            If credits > MaxCredits Then credits = MaxCredits ' But don't let us go over maxcredits 
            ' Turn on Credit light
       		LightCredit.State=1
 			For Each Light in CreditLight:Light.State=1 : Next
            CreditReel() 					' Display the new credit total
			' The match light turns on from a blinking state to indicate Match is made
			For Each Light in MatchLight:Light.State=2 : Next
			' sets the time for match/High Score to flash and restore Attract mode
			' Note that we give a bit extra time if we make a match
			TimerGameEnd.Interval=3000
			TimerGameEnd.Enabled=1
			PlaySound "Knocker" 				' Make some noise
        	PlaySound "MatchMade" ' Play the sound
		Else
			' No Match
			' sets the time for match/High Score to flash and restore Attract mode
			TimerGameEnd.Interval=2000
			TimerGameEnd.Enabled=1
		end if

	Next
	
	' Plays end sound after match. Just replace this with a sound with the same file name
	' or if you want no sound, just delete this from the sound editor.
		'reset for next game
	reeloff=0 ' resets reel match countdown effect for next game	
	Started = False ' reset to show credits can be used for next game
	player = 0						' reset variables
	players = 0
	PlaySound "GameEnd"
	MemoryReset()
	savehs 							' Save the game stats
	
	
End Sub	' End of Sub Match2

' here's where we can turn off the match light from a previous game, or a high score. It will switch
' off anyway at the start of a new game, it's just really polish more than anything.
' While we are at it, we also use this to delay the system so people have the time to see, before
' the system resets and we start attract mode
Sub TimerGameEnd_Timer
	TimerGameEnd.Enabled=0
	For Each Light in MatchLight:Light.State=0 : Next
	PlayerLight(1).state = 0				' Turn off Player Lights
	PlayerLight(2).state = 0
	PlayerLight(3).state = 0
	PlayerLight(4).state = 0
	For y = 1 To 4
    	SetLEDs y - 1, score( y )
    Next
	x = 0 	' this will be used in the attract mode and need it set to known value
	AttractLights()
End sub
'********************************************

'********************************************
' Set the lights to blinking for attract mode
' This is where you add lights for the demo routine, by including them in the "AllLights"
' in the collection Manager. Just add the lights you want in the collection
' Control the patterns and intervals in the table editor
' by using the options menu, and selecting the light by clicking on it.

Sub AttractLights()
	' Code that reads the lights in the Collection for the flashing display
	' Note we switch these lights "OFF" when a game is started, to prevent scripting errors
	' if we use a light state to set a score etc. We define what lights we want on to start a game
	' at the newball sub	
	For Each Light in AllLights:Light.State=2:Next

	TimerAttract.Enabled = True 			' Turn on attract mode
End Sub 'End AttractLights

'This will alternate between displaying the player's score for 4 seconds and the high score for 1.5
' seconds. Note there's 4 case statements, the statements between the score and the high score
' just blank the reels. Looks a lot better

Sub TimerAttract_Timer() 
	if gameover=0 then
		TimerAttract.Enabled=0
		exit sub
	end if
    For Each Light in GameOverLight:Light.State=1 : Next' Turn on the Game Over light

    Select Case x
    	Case 0 ' Displays last score
    		TimerAttract.Interval = 4000					' CHANGE to increase Time for Player's score to display
    		'For Each Light in HSLight:Light.State=0 : Next ' Turn off the high score light
    		For y = 1 To 4
    			SetLEDs y - 1, score( y )
    		Next
    		For each reel in LED1:Reel.SetValue( 1 ):next
    	Case 1 ' blanks the display for 5th of a second
    		TimerAttract.Interval = 200 ' sets 200 miliseconds to blank reels
    		' we use the reel collections, and just set each reel in that collection 
    		' to the first image of the reel (which is off, it's a vp thing that assigns a 0 
    		' value to the first image)
    		For each reel in LED1:Reel.SetValue( 0 ):next
    		For each reel in LED2:Reel.SetValue( 0 ):next
    		For each reel in LED3:Reel.SetValue( 0 ):next
    		For each reel in LED4:Reel.SetValue( 0 ):next
    		For each reel in LED5:Reel.SetValue( 0 ):next
    		For each reel in LED6:Reel.SetValue( 0 ):next
    		For each reel in LED7:Reel.SetValue( 0 ):next
    		' So why is this here instead of in the Case 0 Statement? Because we add the
    		' delay to blank the display, so we want to make sure we blank the HS lights
    		' at the same time, or we get a lag with those lights switching off.
    		For Each Light in HSLight:Light.State=0 : Next ' Turn off the high score light
    	Case 2 ' High score
    		TimerAttract.Interval = 1500					' CHANGE to increase Time HighScore Displayed
    		For Each Light in HSLight:Light.State=1 : Next ' Turn on the high score light
    		For y = 1 To 4
    			SetLEDs y - 1, highscore
    		Next
    		For each reel in LED1:Reel.SetValue( 1 ):next
    	Case 3 ' same as case 1
    		TimerAttract.Interval = 200
    		For each reel in LED1:Reel.SetValue( 0 ):next
    		For each reel in LED2:Reel.SetValue( 0 ):next
    		For each reel in LED3:Reel.SetValue( 0 ):next
    		For each reel in LED4:Reel.SetValue( 0 ):next
    		For each reel in LED5:Reel.SetValue( 0 ):next
    		For each reel in LED6:Reel.SetValue( 0 ):next
    		For each reel in LED7:Reel.SetValue( 0 ):next
    		For Each Light in HSLight:Light.State=0 : Next ' Turn off the high score light
   	End Select

	x = (x + 1) Mod 4 ' This changes what will be displayed next
	
End Sub ' End of Sub TimerAttract_Timer 

'********************************************
' The tilt mechanics here should allow you 4 or 5 quick nudges from the same
' direction before tilting, provided that the tiltswing is at 0.
' You can nudge quite a bit without tilting IF you change nudge direction
' and space the nudges out. The closer the nudgers are together the fewer you get.

Sub TimerTilt_Timer() 								
' This takes care of slowing down and stopping the tilt bob

    tiltswing = (tiltswing / 6) * 5 ' This reduces the swing to 83.33% of its previous value
    If tiltswing < 0.001 Then
       tiltswing = 0 ' Stop the swing when it goes below .001
       TimerTilt.Enabled = False ' And turn off the tilt timer
    End If
    
End Sub ' End of Sub TimerTilt_Timer

'********************************************
' This adds to the swing of the tilt bob and checks to see if we tilted

Sub TiltCheck() 

    TimerTilt.Enabled = True ' We nudged the machine so turn on the tilt timer
    
    ' See if we are shaking the machine in the same direction as the last time
    If newtilt = oldtilt Then
    
       tiltswing = tiltswing + 0.25 ' If so we get a bigger swing increase
       
    Else
    
       tiltswing = tiltswing + 0.18 ' If not we get a smaller increase
    End If
    
    oldtilt = newtilt 						' Save the last nudge direction
    ' This checks if you nudged the table enough to tilt it
    If tiltswing > 1 Then 					' If tiltswing goes over 1 then we tilted
    
       tilt = True ' Set the machine to the tilted state
       
           ' blank displays
	TimerFlashDisplay.Enabled = 0 ' shuts off flashing display if ball in plunger lane
	For each reel in LED1:Reel.SetValue( 0 ):next
    For each reel in LED2:Reel.SetValue( 0 ):next
    For each reel in LED3:Reel.SetValue( 0 ):next
    For each reel in LED4:Reel.SetValue( 0 ):next
    For each reel in LED5:Reel.SetValue( 0 ):next
    For each reel in LED6:Reel.SetValue( 0 ):next
    For each reel in LED7:Reel.SetValue( 0 ):next
       
       For Each Light in TiltLight:Light.State=1 : Next ' Light the tilt light
       
       ' Stop BallSaver light blinking to switch off Ball Saver
       LightBallSaver.State = 0
       
       ' we make sure we don't get a double sound here, so we stop the sound first
       StopAllSounds() ' stops all sounds
       PlaySound "YouTilt" 'play a "Ball lost" sound because you tilted the game
       extraball = False ' switch off the extra ball variable
       
       ' switch off lights
       for each light in AllLights
			light.state=0
		next
		
       
       SetAtTilt()
       ' we look to see if the ball is in the trough, and check the bonus countdown
       ' isn't on, as it has it's own routine to handle a tilt
       if seBallInTrough=1 then
       	
       		' prevent new players from being added
			Started = 0
			
       		' this for the very first ball, as some silly bugger will be sure to check this
       		' switch off the control timer and it's variable
       		'GetTimerControlCode=0
       		'TimerControl.enabled=0
       		TimerBonus.Enabled = False
       		if ball = 0 and player=1 then ball = 1
       		ResetBonus()
       		SetNewBall() ' call custom code set by user
		end if
       
    Else ' or you just nudged it a bit, but not tilted yet
    
    	StopAllSounds() ' stops all sounds
		PlaySound "Tilt" 'play a sound to indicate you nudged
		
    End If
    
End Sub

'*********************************************
Rem Load and Save Highscore Section
' This section handles the loading and saving of data to the hard drive. You should not change anything in this
' section except the names of the items to be loaded or saved.

' TableName below is defined to be the name for this table at top of the script.

Sub savehs

	SaveValue TableName, "HighScore", HighScore 'high score
    SaveValue TableName, "Credits", Credits 'credits
    SaveValue TableName, "Balls per game", Balls 'credits
	
End Sub ' End of Sub savehs

'********************************************
Sub loadhs
	dim Value
    Value = LoadValue(TableName, "HighScore")'high score
	If (Value <> "") Then highscore = CDbl(Value)End If 
	Value = LoadValue(TableName, "Credits")'credits
	If (Value <> "") Then credits = CDbl(Value)End If 
	Value = LoadValue(TableName, "Balls")'balls per game
	If (Value <> "") Then Balls = CDbl(Value)End If

End Sub ' End of Sub loadhs
 

'********************************************

Function FormatLightString(ByVal State)

	If State = 1 Then FormatLightString = "1"
	
  	If State = 0 Then FormatLightString = "0"

	If State = 2 Then FormatLightString = "2"
	
End Function ' End of Function FormatLightString

'********************************************
Rem End shivaEngine Code
